VERSION 4.00
Begin VB.Form TestSema 
   Caption         =   "Test Semaphore"
   ClientHeight    =   3135
   ClientLeft      =   1095
   ClientTop       =   1515
   ClientWidth     =   3735
   Height          =   3540
   Left            =   1035
   LinkTopic       =   "Form1"
   ScaleHeight     =   3135
   ScaleWidth      =   3735
   Top             =   1170
   Width           =   3855
   Begin VB.TextBox Timeout 
      Height          =   285
      Left            =   1920
      TabIndex        =   10
      Text            =   "0"
      Top             =   1800
      Width           =   495
   End
   Begin VB.CommandButton Exit 
      Caption         =   "E&xit"
      Height          =   375
      Left            =   2040
      TabIndex        =   14
      Top             =   2640
      Width           =   1575
   End
   Begin VB.CheckBox Released 
      Caption         =   "Released"
      Enabled         =   0   'False
      Height          =   255
      Left            =   2640
      TabIndex        =   0
      Top             =   2160
      Value           =   2  'Grayed
      Width           =   975
   End
   Begin VB.Timer Second 
      Interval        =   1000
      Left            =   240
      Top             =   480
   End
   Begin VB.TextBox Max 
      Height          =   375
      Left            =   1680
      TabIndex        =   7
      Text            =   "1"
      Top             =   1320
      Width           =   855
   End
   Begin VB.TextBox Initial 
      Height          =   375
      Left            =   1680
      TabIndex        =   5
      Text            =   "1"
      Top             =   960
      Width           =   855
   End
   Begin VB.TextBox RelCount 
      Height          =   285
      Left            =   1920
      TabIndex        =   13
      Text            =   "1"
      Top             =   2160
      Width           =   495
   End
   Begin VB.CommandButton Release 
      Caption         =   "&Release"
      Height          =   375
      Left            =   120
      TabIndex        =   11
      Top             =   2160
      Width           =   855
   End
   Begin VB.CheckBox Acquired 
      Caption         =   "Acquired"
      Enabled         =   0   'False
      Height          =   255
      Left            =   2640
      TabIndex        =   1
      Top             =   1800
      Value           =   2  'Grayed
      Width           =   975
   End
   Begin VB.CommandButton Acquire 
      Caption         =   "&Acquire"
      Height          =   375
      Left            =   120
      TabIndex        =   8
      Top             =   1680
      Width           =   855
   End
   Begin VB.TextBox SemaName 
      Height          =   375
      Left            =   1800
      TabIndex        =   3
      Text            =   "Haggises"
      Top             =   120
      Width           =   1815
   End
   Begin VB.Label Label5 
      Caption         =   "&Count"
      Height          =   255
      Left            =   1080
      TabIndex        =   12
      Top             =   2160
      Width           =   735
   End
   Begin VB.Label Label4 
      Caption         =   "&Timeout"
      Height          =   255
      Left            =   1080
      TabIndex        =   9
      Top             =   1800
      Width           =   735
   End
   Begin PHDSEMALib.Sema Sema 
      Left            =   840
      Top             =   480
      _Version        =   65536
      _ExtentX        =   450
      _ExtentY        =   450
      _StockProps     =   1
   End
   Begin VB.Label ReleaseRV 
      Height          =   255
      Left            =   120
      TabIndex        =   19
      Top             =   2640
      Width           =   495
   End
   Begin VB.Label running 
      Height          =   255
      Left            =   3120
      TabIndex        =   18
      Top             =   1800
      Width           =   495
   End
   Begin VB.Label ActualMax 
      Height          =   375
      Left            =   2640
      TabIndex        =   17
      Top             =   1320
      Width           =   855
   End
   Begin VB.Label ActualInitial 
      Height          =   375
      Left            =   2640
      TabIndex        =   16
      Top             =   960
      Width           =   855
   End
   Begin VB.Label ActualName 
      Height          =   255
      Left            =   1680
      TabIndex        =   15
      Top             =   600
      Width           =   1815
   End
   Begin VB.Label Label3 
      Caption         =   "&Maximum count"
      Height          =   255
      Left            =   120
      TabIndex        =   6
      Top             =   1320
      Width           =   1455
   End
   Begin VB.Label Label2 
      Caption         =   "&Initial count"
      Height          =   255
      Left            =   120
      TabIndex        =   4
      Top             =   960
      Width           =   1455
   End
   Begin VB.Label Label1 
      Caption         =   "&Semaphore Name:"
      Height          =   255
      Left            =   120
      TabIndex        =   2
      Top             =   120
      Width           =   1455
   End
End
Attribute VB_Name = "TestSema"
Attribute VB_Creatable = False
Attribute VB_Exposed = False

Option Explicit

Private Sub Exit_Click()
    Unload Me
End Sub

Private Sub Form_Load()
    Second_Timer
    running = Val(Initial)
End Sub

Private Sub Initial_Change()
    If IsNumeric(Initial) Then
        Sema.InitialCount = Initial
        running = Val(Initial)
    End If
End Sub

Private Sub Max_Change()
    If IsNumeric(Max) Then
        Sema.MaximumCount = Max
        running = Val(Initial)
    End If

End Sub
Private Sub Second_Timer()
    actualname = Sema.SemaphoreName
    ActualInitial = Sema.InitialCount
    ActualMax = Sema.MaximumCount
End Sub
Private Sub Acquire_Click()
    Acquired = 2
    If Not IsNumeric(Timeout) Then
        MsgBox "Timeout not numeric"
        Timeout.SetFocus
    End If
    Dim ok As Boolean
    ok = Sema.Acquire(Timeout)
    Acquired = IIf(ok, 1, 0)
    If ok Then running = Val(running) - 1
End Sub
Private Sub Release_Click()
    If Not IsNumeric(RelCount) Then
        MsgBox "Release count not numeric"
        RelCount.SetFocus
    End If
    If RelCount <= 0 Then
        MsgBox "Release count must be >= 1"
        RelCount.SetFocus
    End If
    Dim ok As Long
    ok = Sema.Release(RelCount)
    Released = IIf(ok <> -1, 1, 0)
    ReleaseRV = ok
    If ok Then running = Val(running) + Val(RelCount)
End Sub

Private Sub Semaname_Change()

    Sema.SemaphoreName = Semaname
    running = Val(Initial)
End Sub
